/*
  time-stamp: <03/03/28 11:03:29 kawasan>
  Time-stamp: <04/07/27 11:51:52 kawasan>

  ATmega103UARTץ

  K_mon_systemưǧ
  <pre>
  ATmega103Υ־

  [ORIGINAL]
  Program-Area $0000 - $FFFF Flash    (64K x 16)
  Data-Area    $0000 - $001F reg  (32 x 8)
               $0020 - $005F I/O-reg  (64 x 8)
               $0060 - $0FFF ¢SRAM (4000 x 8)
               $1000 - $FFFF SRAM (060K x 8)
  EEPROM-Area  $0000 - $0FFF EEPROM   (4K x 8)

  [AVR_Core (default)]
  Program-Area $0000 - $03FF Flash    (1K x 16)
  Data-Area    $0000 - $001F reg  (32 x 8)
               $0020 - $005F I/O-reg  (64 x 8)
               $0060 - $00DF ¢SRAM (128 x 8)

  [AVR_Core (now)]
  Program-Area $0000 - $03FF Flash    (1K x 16) 񸻤64KOK
  Data-Area    $0000 - $001F reg  (32 x 8)
               $0020 - $005F I/O-reg  (64 x 8)
               $0060 - $105f ¢SRAM (4096 x 8)
  </pre>
*/


/*!
  \file k_mon_system.c
  \brief K_mon_systemưǧ
*/


#include <io.h>
#include <interrupt.h>
#include <sig-avr.h>
#include <progmem.h>


typedef unsigned char	BYTE;
typedef unsigned short	WORD;
typedef unsigned long	DWORD;


#define TRUE  1
#define FALSE 0

#if 1
/* CK=12MHz */
#define PRESET_1MS ( 256 - 12 )
#define PRESET_TCCR0 ( 0x07 ) /* ATmega103 */
#define PRESET_UBRR ( 77 )
#endif

#if 0
/* CK=6MHz */
#define PRESET_1MS ( 256 - 6 )
#define PRESET_TCCR0 ( 0x07 ) /* ATmega103 */
#define PRESET_UBRR ( 38 )
#endif

#if 0
/* CK=3MHz */
#define PRESET_1MS ( 256 - 3 )
#define PRESET_TCCR0 ( 0x07 ) /* ATmega103 */
#define PRESET_UBRR ( 19 )
#endif

/* K_mon_System */
#define	K_MON_A_SIZE	( 2 )   /* 2byte = 0-ffffh */
#define	K_MON_VERSION	( '2' ) /* System_version */
#define	K_MON_CODE_ACK ( 'A' )
#define	K_MON_CODE_NAK ( 'N' )
#define	K_MON_CODE_ADD ( 'a' )
#define	K_MON_CODE_BUS ( 'b' )
#define	K_MON_CODE_MWR ( 'w' )
#define	K_MON_CODE_MRD ( 'r' )
#define	K_MON_CODE_PRD ( 'R' )
#define	K_MON_CODE_IWR ( 'o' )
#define	K_MON_CODE_IRD ( 'i' )
#define	K_MON_CODE_VER ( 'v' )
#define	K_MON_CODE_CAL ( 'c' )
#define	K_MON_CODE_GO  ( 'g' )
#define pokeb(a,b) ( *(volatile unsigned char *)(a) = (b) )
#define peekb(a) ( *(volatile unsigned char *)(a) )
#define k_mon_getc() inp( UDR )
#define k_mon_putc(a) outp( (a), UDR )


BYTE f_1s;
WORD wTime1sec_cnt;
WORD debug_counter00;
WORD wTime10ms_cnt;
DWORD debug_counter01;

/* K_mon_System */
WORD moniter_reg_a;		/* ɥ쥹 */
BYTE moniter_reg_mode;		/* ⡼ɵ */
BYTE moniter_reg_cnt;		/* ɥ쥹Υ */


PROGMEM char version_code[] = {
//---0123456789abcdef0123456789abcdef---
    "K_mon_System   "			// Program Name (No edit)
    "\0"
    "1.07   "				// Firmware-Version
    "\0"
    "kawasan"				// Maker
    "\0"
//  "Thu Oct 30 18:54:12 2003"		// First date
    "Tue Jul 27 11:51:52 2004"		// Last Update
    "\0"
};


void bg_task( void );


/*!
  Init Timer0

  Timer08bitޤOverFlowǤγߤѤ롣
  1msǳư롣
*/
void tmr0_init( void )
{
    /* preset CNT0 */
    outp( PRESET_1MS, TCNT0 );

    /* set prescaler CK/1024 */
    outp( PRESET_TCCR0, TCCR0 );

    /* enable TMR0 interrupt */
    outp( inp( TIMSK ) | BV( TOIE0 ), TIMSK );

    /* Init 1secưflag */
    f_1s = FALSE;
    wTime1sec_cnt = 1000;
}


/*!
  interrupt function (timer0 OverFlow)

  1ms˳ߵư
*/
SIGNAL( SIG_OVERFLOW0 )
{
    /* preset CNT0 */
    outp( PRESET_1MS, TCNT0 );

    /* 10msưѽ */
    wTime10ms_cnt --;
    if ( wTime10ms_cnt == 0 ) {
	wTime10ms_cnt = 10;

	// 10ms˸ޤꤦͤϡ999  0 1000ʳǤ
	debug_counter00 --;
	if ( debug_counter00 == 0xffff ) {
	    debug_counter00 = 999;
	}

	/* LEDȿž */
	outp( inp( PINB ) ^ 0x04, PORTB );	/* 0000_0100 */
    }

    /* 1õưѽ */
    wTime1sec_cnt --;
    if ( wTime1sec_cnt == 0 ) {
	f_1s = TRUE;
	wTime1sec_cnt = 1000;
    }

    /* 1msINC */
    debug_counter01 ++;

    /* LEDȿž */
    outp( inp( PINB ) ^ 0x01, PORTB );	/* 0000_0001 */
}


/*!
  Init UART

  9600bps 8bit-Data 1stop-bit Non-parity
  ߤѤ
*/
void uart_init( void )
{
    /* enable RxInt, RxD, TxD */
    outp( BV( RXCIE ) | BV( RXEN ) | BV( TXEN ), UCR );

    /* 9600bps */
    outp( PRESET_UBRR, UBRR );
}


/*!
  interrupt function (UART )

  K_mon_System
*/
SIGNAL( SIG_UART_RECV )
{
    BYTE rev_dat;
    BYTE tx_dat;


    rev_dat = k_mon_getc();

    /* ϡ˥ǽƳ߽Ȥ */
    /* ei(); */

    if ( moniter_reg_mode == 0 ) {
	switch ( rev_dat ) {
	case K_MON_CODE_BUS:
	    moniter_reg_a = 0;
	    k_mon_putc( K_MON_A_SIZE );
	    break;
	case K_MON_CODE_ADD:
	    moniter_reg_mode = K_MON_CODE_ADD;
	    moniter_reg_a = 0;
	    moniter_reg_cnt = 0;
	    k_mon_putc( rev_dat );
	    break;
	case K_MON_CODE_MWR:
	    moniter_reg_mode = K_MON_CODE_MWR;
	    k_mon_putc( rev_dat );
	    break;
	case K_MON_CODE_MRD:
	    tx_dat = peekb( moniter_reg_a );
	    moniter_reg_a++;	/* Set next point */
	    k_mon_putc( tx_dat );
	    break;
	case K_MON_CODE_PRD:
	    tx_dat = PRG_RDB( moniter_reg_a );
	    moniter_reg_a++;	/* Set next point */
	    k_mon_putc( tx_dat );
	    break;
	case K_MON_CODE_VER:
	    k_mon_putc( K_MON_VERSION );
	    break;
	default:
	    k_mon_putc( K_MON_CODE_NAK );
	    break;
	}
    } else {
	switch ( moniter_reg_mode ) {
	case K_MON_CODE_MWR:
	    pokeb( moniter_reg_a, rev_dat );
	    moniter_reg_a++;	/* Set next point */
	    moniter_reg_mode = 0; /* mode = 0 */
	    k_mon_putc( rev_dat );
	    break;
	case K_MON_CODE_ADD:
	    moniter_reg_a <<= 8;
	    moniter_reg_a += rev_dat;
	    moniter_reg_cnt++;
	    if ( moniter_reg_cnt >= K_MON_A_SIZE ) {
		/* mode = 0 */
		moniter_reg_mode = 0;
	    }
	    k_mon_putc( rev_dat );
	    break;
	default:
	    /* ꡼*/
	    moniter_reg_mode = 0; /* mode = 0 */
	    k_mon_putc( K_MON_CODE_NAK );
	    break;
	}
    }
}


/*!
  Main-Routine
*/
int main( void )
{
    cli();

    /* Init Port */
    outp( 0x00, DDRA );		/* out:o,in:i,(iiiiiiii) -> (0000_0000) */
    outp( 0x00, PORTA );	/* inputԥpullupˤ   0000_0000 */
    outp( 0x0f, DDRB );		/* out:o,in:i,(iiiioooo) -> (0000_1111) :DegiSW=0λ */
    outp( 0x00, PORTB );	/* inputԥpullupˤ   0000_0000 */
    //outp( 0xf0, DDRC );		/* out:o,in:i,(ooooiiii) -> (1111_0000) */
    //outp( 0x20, PORTC );	/* inputԥpullupˤ   0010_0000 */
    //outp( 0xff, DDRD );		/* out:o,in:i,(oooooooo) -> (1111_1111) */
    //outp( 0x00, PORTD );	/* inputԥpullupˤ   0000_0000 */


    /* ޳ߤ */
    tmr0_init();

    /* UARTߤ */
    uart_init();

    /* ѿ */
    debug_counter00 = 999;
    debug_counter01 = 0;
    wTime10ms_cnt = 10;
    moniter_reg_mode = 0;

    /* enable grobal interrupt */
    sei();

    while( 1 ) {
        bg_task();
    }

    return 0;
}


/*!
  Back Ground TASK
*/
void bg_task( void )
{
    if ( f_1s == TRUE ) {
        /* 1˽ */
        f_1s = FALSE;

        cli();
        /* LEDȿž */
        outp( inp( PINB ) ^ 0x02, PORTB );	/* 0000_0010 */
        sei();
    }

    cli();
    /* LEDȿž */
    outp( inp( PINB ) ^ 0x08, PORTB );	/* 0000_1000 */
    sei();
}
