--***************************************************************
--* File         : CHGCLK.vhd                                   *
--* Created      : time-stamp: <08/05/02 02:19:14 kawasan>      *
--* Modified     : Time-stamp: <08/06/13 02:35:18 kawasan>      *
--*                                                             *
--* CHGCLK (dummy)                                              *
--*                                                             *
--* Copyright 2008 Osamu Kawashima. all rights reserved         *
--***************************************************************

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity CHGCLK is
	generic (
		CLOCK_TYPE      : string  := "DEFAULT"		-- DEFAULT or ACTEL_CLKINT or XILINX_GCLK
	);
	port (
		RESI            : in    std_logic;
		CLKI            : in    std_logic;
		CLKO            : out   std_logic
	);
end CHGCLK;

architecture RTL of CHGCLK is

	component CLKINT
	port (
		A               : in    std_logic;
		Y               : out   std_logic
	);
	end component;

	component BUFG
	port (
		I               : in std_logic;
		O               : out std_logic
	);
	end component;

	signal clk              : std_logic_vector(1 downto 0);

begin

	process (CLKI)
	begin
		if CLKI'event and CLKI='1' then
			if RESI='1' then
				clk <= (others=>'0');
			else
				clk <= clk + 1;
			end if;
		end if;
	end process;

	uGCLKD_DEFAULT:
	if CLOCK_TYPE="DEFAULT" generate
		CLKO <= clk(1);
	end generate;

	uGCLKD_ACTEL_CLKINT:
	if CLOCK_TYPE="ACTEL_CLKINT" generate
	uCLKINT : CLKINT
	port map (
		A               => clk(1),
		Y               => CLKO
	);
	end generate;

	uGCLKD_XILINX_GCLK:
	if CLOCK_TYPE="XILINX_GCLK" generate
	uBUFG : BUFG
	port map (
		I               => clk(1),
		O               => CLKO
	);
	end generate;

end RTL;
