/*
  time-stamp: <04/05/22 18:55:31 kawasan>
  Time-stamp: <04/05/27 20:38:15 kawasan>
*/

/*!
  \file hex2vhdl.c
  \brief Hex-fileVHDL-fileѴ (XilinxBlockRAMƤ)
*/


#define PNAME "hex2vhdl"
#define VERSION "Hex-file to VHDL-file converter (ver 0.1)"
#define BUF_SIZE 1024
#define MAXSTR 1024
#define DATA_SIZE ( 1024 * 64 * 2 )	// 礨64KWord߷פƤߤ


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <time.h>


typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned char BOOL;
typedef unsigned long DWORD;


/*!
  Ƭ2ʸHex-CodeȤBYTEѴ

  \param buf ʸΥݥ
  \return Ѵ
*/
BYTE gethex( char *buf )
{
    char tmp_buf[ 3 ];
    int	 hex_dat;

    tmp_buf[ 0 ] = *( buf + 0 ) ;
    tmp_buf[ 1 ] = *( buf + 1 ) ;
    tmp_buf[ 2 ] = 0;
    sscanf( tmp_buf, "%x", &hex_dat );

    return (BYTE)hex_dat;
}


/*!
  Hex-fileɤХåե˥ǡǼ

  \param buf ǼΥХåեݥ
  \param rd_fp ɤ߽ФFILEݥ
  \return 0ʤ
*/
int hex2buf( BYTE *buf, FILE *rd_fp )
{
    char buffer[ BUF_SIZE ];
    BYTE dat[ BUF_SIZE ];
    DWORD add;
    DWORD segment;
    int	 cnt;
    int	 cnt2;
    int	 ln;
    int	 type;
    int	 end_flag;
    int	 dat0;
    int	 chk;


    end_flag = 0;
    segment = 0;


    /* 1ɤ߹ǤϥХʥѴ */
    while ( end_flag == 0 ) {
	cnt = 0;
	chk = 0;

	/* Fileνλ */
	if ( fgets( buffer, BUF_SIZE, rd_fp ) == NULL ) {
	    break;
	}

	/*  쥳ɡޡ */
	if ( buffer[ cnt ] != ':' ) {
	    fprintf( stderr, "\nCode error![%02X]", buffer[ cnt ] );
	    break;
	}

	/* Get 쥳Ĺ */
	cnt++;
	ln = gethex( buffer + cnt );
	chk += ln;

	/* Get ɡɥ쥹 */
	cnt += 2;
	dat0 = gethex( buffer + cnt );
	add = ( (DWORD)dat0 << 8 );
	chk += dat0;
	dat0 = gethex( buffer + cnt + 2 );
	add += (DWORD)dat0;
	chk += dat0;

	/* Get 쥳ɡ */
	cnt += 4;
	type = gethex( buffer + cnt );
	chk += type;

	/* Get ǡ */
	cnt2 = 0;
	while ( ln > cnt2 ){
	    cnt += 2;
	    chk += dat[ cnt2++ ] = gethex( buffer + cnt );
	}

	/* Get å */
	cnt += 2;
	dat0 = gethex( buffer + cnt );
	if ( (BYTE)( ( ( ~(BYTE)chk ) + 1 ) ) != (BYTE )dat0 ) {
	    fprintf( stderr, "\nCheck_sum error![%02X:%02X]",
		    (BYTE)chk, dat0 );
	    break;
	}

	switch ( type ) {
	case ( 0x00 ):
	    cnt2 = 0;
	    while ( ln > cnt2 ) {
		buf[(DWORD)( ( segment << 16 ) + add )] = dat[ cnt2++ ];
		add++;
	    }
	    break;
	case ( 0x01 ):
	    end_flag = 0x01;
	    break;
	case ( 0x02 ):
	    /* Get ĥɥ쥹 */
	    segment = ( (DWORD)dat[ 0 ] << 8 ) + (DWORD)dat[ 1 ];
	    break;
	case ( 0x03 ):
	    /* Get ȡɥ쥹 */
	    segment = ( (DWORD)dat[ 0 ] << 8 ) + (DWORD)dat[ 1 ];
	    /* ΤȤϥȽϤޤ */
	    break;
	default:
	    fprintf( stderr, "\nType error!" );
	    break;
	}
    }

    return 0;
}


/*!
  HELPɽ
*/
void usage( void )
{
    fprintf( stderr, "Usage: %s filename modulename asize dsize\n", PNAME );
    fprintf( stderr, "%s\n", VERSION );
    fprintf( stderr, "\n");
    fprintf( stderr, "ex.\n");
    fprintf( stderr, "    Hex-file = test.hex\n" );
    fprintf( stderr, "    Module-name = PROM\n" );
    fprintf( stderr, "    Address-Bus Width = 10bit\n" );
    fprintf( stderr, "    Data-Bus Width = 16bit\n" );
    fprintf( stderr, "    %s test.hex PROM 10 16\n", PNAME );
}


/*!
  ǡͤBIN-codeʸѴǼ

  \param dat ǡ
  \param dsize ǡХBIT
  \return 0ʤ
*/
int i2strbin( DWORD dat, int dsize, char *tmp )
{
    int cnt;
    DWORD cmp;


    if ( dsize > 16 ) {
	fprintf( stderr, "Error : i2strbin : Non support dsize!\n" );
	return -1;
    }

    cmp = 1 << ( dsize - 1 );
    for ( cnt = dsize - 1; cnt >= 0 ; cnt -- ) {
	if ( cmp & dat ) {
	    *tmp = '1';
	} else {
	    *tmp = '0';
	}
	tmp ++;
	cmp >>= 1;
    }
    *tmp = 0;

    return 0;
}


/*!
  ХåեΥǡϤ

  \param buf ǡΥХåեݥ
  \param asize ɥ쥹ХBIT
  \param dsize ǡХBIT
  \return 0ʤ
*/
int writeout( BYTE *buf, int asize, int dsize )
{
    BYTE *pnt;
    DWORD add;
    DWORD add_end;
    DWORD dat;
    char tmp[ MAXSTR ];
    char tmp_c;


    add_end = 1 << asize;

    for ( add = 0; add < add_end; add ++ ) {
	if ( dsize <= 8 ) {
	    pnt = (BYTE *)( buf + add );
	    dat = (DWORD)*pnt;
	} else if ( dsize <= 16 ) {
	    pnt = (BYTE *)( buf + add * 2 );
	    dat = (DWORD)( *pnt ) + ( (DWORD)( *( pnt + 1 ) ) * 0x100 );
	} else {
	    fprintf( stderr, "Error : writeout : Non support dsize!\n" );
	    return -1;
	}

	i2strbin( dat, dsize, tmp );

	if ( add + 1 < add_end ) {
	    tmp_c = ',';
	} else {
	    tmp_c = ' ';
	}

	printf( "\t\"%s\"%c\t-- %04lx\n", tmp, tmp_c, add );
    }

    return 0;
}


/*!
  ȥХå饦ɽ
*/
int main( int argc, char *argv[] )
{
    FILE *rd_fp;
    char fname[ MAXSTR ];
    char mname[ MAXSTR ];
    char tmp[ MAXSTR ];
    int asize;
    int dsize;
    BYTE buf[ DATA_SIZE ];
    int cnt;
    time_t timer;
    struct tm *date;


    if ( argc != ( 4 + 1 ) ) {
	usage();
	exit( -1 );
    }

    strcpy( fname, argv[ 1 ] );
    strcpy( mname, argv[ 2 ] );
    sscanf( argv[ 3 ], "%d", &asize );
    sscanf( argv[ 4 ], "%d", &dsize );

    /* Open Hex-file */
    if ( ( rd_fp = fopen( fname, "r" ) ) == NULL ) {
	fprintf( stderr, "Can't Open file [%s]!\n", fname );
	exit( -1 );
    }

    /* Clear buffer */
    for ( cnt = 0; cnt < DATA_SIZE; cnt ++ ) {
	buf[ cnt ] = 0xff;
    }

    /* Set buffer */
    if ( hex2buf( buf, rd_fp ) ) {
	fprintf( stderr, "Hex-file is data-format error." );
	fclose( rd_fp );
	exit( -1 );
    }

    /* Close Hex-file */
    fclose( rd_fp );

    /* --- Write ------------------------- */
    timer = time( NULL );
    date = localtime( &timer );
    printf( "-- %s (kawasan) %s\n", PNAME, asctime( date ) );
    puts( "library IEEE;" );
    puts( "use IEEE.std_logic_1164.all;" );
    puts( "use IEEE.std_logic_unsigned.all;" );
    puts( "use IEEE.std_logic_arith.all;\n" );
    puts( "entity PROM is" );
    puts( "\tport(" );
    puts( "\t\tCLK\t: in std_logic;" );
    printf( "\t\tADD\t: in std_logic_vector(%d downto 0);\n", asize - 1 );
    printf( "\t\tDO\t: out std_logic_vector(%d downto 0)\n", dsize - 1 );
    puts( "\t);" );
    puts( "end PROM;\n" );
    puts( "architecture rtl of PROM is" );
    puts( "\tsignal WR\t: std_logic := '0';" );
    i2strbin( 0, dsize, tmp );
    printf( "\tsignal DI\t: std_logic_vector(%d downto 0) := \"%s\";\n", dsize - 1, tmp );
    printf( "\tsignal ADDR_REG : std_logic_vector(%d downto 0);\n", asize - 1 );
    printf( "\ttype rom_type is array (0 to (2**(%d+1))-1) of std_logic_vector (%d downto 0);\n", asize - 1, dsize - 1 );
    puts( "\tsignal ROM : rom_type := (" );

    writeout( buf, asize, dsize );

    puts( "\t);" );
    puts( "begin" );
    puts( "\tprocess (CLK)" );
    puts( "\tbegin" );
    puts( "\t\tif (CLK'event and CLK = '1') then" );
    puts( "\t\t\tif (WR = '1') then" );
    puts( "\t\t\t\tROM(CONV_INTEGER(ADD)) <= DI;" );
    puts( "\t\t\tend if;" );
    puts( "\t\t\tADDR_REG <= ADD;" );
    puts( "\t\tend if;" );
    puts( "\tend process;" );
    puts( "\tDO <= ROM(CONV_INTEGER(ADDR_REG));" );
    puts( "end;" );

    return 0;
}
